commit 998636a4f8493855a351bb1080fc7687269cb9f9
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Wed Nov 12 11:20:42 2025 +0000

    library versions

diff --git a/src/src/exim.c b/src/src/exim.c
index 9d6f858bd..13cc4ff2c 100644
--- a/src/src/exim.c
+++ b/src/src/exim.c
@@ -1316,19 +1316,15 @@ Currently they are output in misc_mod_add() */
 #ifndef PCRE_PRERELEASE
 # define PCRE_PRERELEASE
 #endif
-#define QUOTE(X) #X
-#define EXPAND_AND_QUOTE(X) QUOTE(X)
     {
     uschar buf[24];
     pcre2_config(PCRE2_CONFIG_VERSION, buf);
     g = string_fmt_append(g, "Library version: PCRE2: Compile: %d.%d%s\n"
 		"                        Runtime: %s\n",
 	    PCRE2_MAJOR, PCRE2_MINOR,
-	    EXPAND_AND_QUOTE(PCRE2_PRERELEASE) "",
+	    mac_expanded_string(PCRE2_PRERELEASE) "",
 	    buf);
     }
-#undef QUOTE
-#undef EXPAND_AND_QUOTE
 
   show_string(is_stdout, g);
   g = NULL;
diff --git a/src/src/lookups/cdb.c b/src/src/lookups/cdb.c
index b56306a7f..98ff462a3 100644
--- a/src/src/lookups/cdb.c
+++ b/src/src/lookups/cdb.c
@@ -462,10 +462,8 @@ if (cdbp->cdb_map)
 gstring *
 cdb_version_report(gstring * g)
 {
-#ifdef DYNLOOKUP
-g = string_fmt_append(g, "Library version: CDB: Exim version %s\n", EXIM_VERSION_STR);
-#endif
-return g;
+return string_fmt_append(g, "Library version: CDB: Exim %s builtin\n",
+			  EXIM_VERSION_STR);
 }
 
 
diff --git a/src/src/lookups/dnsdb.c b/src/src/lookups/dnsdb.c
index d08f6122e..6e2be8ae1 100644
--- a/src/src/lookups/dnsdb.c
+++ b/src/src/lookups/dnsdb.c
@@ -591,10 +591,8 @@ return rc;
 gstring *
 dnsdb_version_report(gstring * g)
 {
-#ifdef DYNLOOKUP
-g = string_fmt_append(g, "Library version: DNSDB: Exim version %s\n", EXIM_VERSION_STR);
-#endif
-return g;
+return string_fmt_append(g, "Library version: DNSDB: Exim %s builtin\n",
+			    EXIM_VERSION_STR);
 }
 
 
diff --git a/src/src/lookups/dsearch.c b/src/src/lookups/dsearch.c
index 99e1c8648..4fb8f0c27 100644
--- a/src/src/lookups/dsearch.c
+++ b/src/src/lookups/dsearch.c
@@ -172,10 +172,8 @@ handle = handle;   /* Avoid compiler warning */
 gstring *
 dsearch_version_report(gstring * g)
 {
-#ifdef DYNLOOKUP
-g = string_fmt_append(g, "Library version: dsearch: Exim version %s\n", EXIM_VERSION_STR);
-#endif
-return g;
+return string_fmt_append(g, "Library version: dsearch: Exim %s builtin\n",
+			  EXIM_VERSION_STR);
 }
 
 
diff --git a/src/src/lookups/json.c b/src/src/lookups/json.c
index 43575cacf..3e5f9609e 100644
--- a/src/src/lookups/json.c
+++ b/src/src/lookups/json.c
@@ -162,7 +162,8 @@ json_close(void *handle)
 gstring *
 json_version_report(gstring * g)
 {
-return string_fmt_append(g, "Library version: json: Jansonn version %s\n", JANSSON_VERSION);
+return string_fmt_append(g, "Library version: json: Jansonn version %s\n",
+			  JANSSON_VERSION);
 }
 
 
diff --git a/src/src/lookups/ldap.c b/src/src/lookups/ldap.c
index a6e99f567..c657797d9 100644
--- a/src/src/lookups/ldap.c
+++ b/src/src/lookups/ldap.c
@@ -1563,11 +1563,29 @@ return quoted;
 gstring *
 ldap_version_report(gstring * g)
 {
-#ifdef DYNLOOKUP
-/*XXX it would be nice to haul a version string for the underlying ldap library */
-g = string_fmt_append(g, "Library version: LDAP: Exim version %s\n", EXIM_VERSION_STR);
-#endif
+#ifdef LDAP_LIB_OPENLDAP2
+LDAP * ld = ldap_init("", 0);
+LDAPAPIInfo info = {.ldapai_info_version = LDAP_API_INFO_VERSION};
+
+g = string_fmt_append(g, "Library version: LDAP: Compile %s %u.%u.%u\n",
+    LDAP_VENDOR_NAME, LDAP_VENDOR_VERSION_MAJOR,
+    LDAP_VENDOR_VERSION_MINOR, LDAP_VENDOR_VERSION_PATCH);
+
+if (ldap_get_option(ld, LDAP_OPT_API_INFO, &info) == LDAP_OPT_SUCCESS)
+  {
+  g = string_fmt_append(g, "                       Runtime %s %d\n",
+      info.ldapai_vendor_name, info.ldapai_vendor_version);
+
+  for (char ** sp = info.ldapai_extensions; *sp; *sp++)
+    ldap_memfree(*sp);
+  ldap_memfree(info.ldapai_extensions);
+  ldap_memfree(info.ldapai_vendor_name);
+  }
 return g;
+
+#else
+return string_fmt_append(g, "Library version: LDAP: (unknown)\n");
+#endif
 }
 
 
diff --git a/src/src/lookups/lmdb.c b/src/src/lookups/lmdb.c
index 3a3eebcba..c90632cee 100644
--- a/src/src/lookups/lmdb.c
+++ b/src/src/lookups/lmdb.c
@@ -134,10 +134,9 @@ gstring *
 lmdb_version_report(gstring * g)
 {
 g = string_fmt_append(g, "Library version: LMDB: Compile: %d.%d.%d\n",
-			  MDB_VERSION_MAJOR, MDB_VERSION_MINOR, MDB_VERSION_PATCH);
-#ifdef DYNLOOKUP
-g = string_fmt_append(g, "                        Exim version %s\n", EXIM_VERSION_STR);
-#endif
+		      MDB_VERSION_MAJOR, MDB_VERSION_MINOR, MDB_VERSION_PATCH);
+g = string_fmt_append(g, "                       Runtime: %s\n",
+		      mdb_version(NULL, NULL, NULL));
 return g;
 }
 
diff --git a/src/src/lookups/lsearch.c b/src/src/lookups/lsearch.c
index 89a9e6c80..fc7ebaf62 100644
--- a/src/src/lookups/lsearch.c
+++ b/src/src/lookups/lsearch.c
@@ -418,10 +418,8 @@ lsearch_close(void *handle)
 gstring *
 lsearch_version_report(gstring * g)
 {
-#ifdef DYNLOOKUP
-g = string_fmt_append(g, "Library version: lsearch: Exim version %s\n", EXIM_VERSION_STR);
-#endif
-return g;
+return string_fmt_append(g, "Library version: lsearch: Exim %s builtin\n",
+			    EXIM_VERSION_STR);
 }
 
 
diff --git a/src/src/lookups/mysql.c b/src/src/lookups/mysql.c
index bbf98cb0c..76954ca43 100644
--- a/src/src/lookups/mysql.c
+++ b/src/src/lookups/mysql.c
@@ -475,12 +475,8 @@ mysql_version_report(gstring * g)
 g = string_fmt_append(g,
   "Library version: MySQL: Compile: %lu %s [%s]\n"
   "                        Runtime: %lu %s\n",
-        (long)EXIM_MxSQL_VERSION_ID, EXIM_MxSQL_VERSION_STR, EXIM_MxSQL_BASE_STR,
-        mysql_get_client_version(), mysql_get_client_info());
-#ifdef DYNLOOKUP
-g = string_fmt_append(g,
-  "                        Exim version %s\n", EXIM_VERSION_STR);
-#endif
+      (long)EXIM_MxSQL_VERSION_ID, EXIM_MxSQL_VERSION_STR, EXIM_MxSQL_BASE_STR,
+      mysql_get_client_version(), mysql_get_client_info());
 return g;
 }
 
diff --git a/src/src/lookups/nis.c b/src/src/lookups/nis.c
index aa12f4742..77f6b0f68 100644
--- a/src/src/lookups/nis.c
+++ b/src/src/lookups/nis.c
@@ -101,6 +101,7 @@ return (rc == YPERR_KEY || rc == YPERR_MAP)? FAIL : DEFER;
 gstring *
 nis_version_report(gstring * g)
 {
+/* maybe part of glibc? */
 #ifdef DYNLOOKUP
 g = string_fmt_append(g, "Library version: NIS: Exim version %s\n", EXIM_VERSION_STR);
 #endif
diff --git a/src/src/lookups/nmh.c b/src/src/lookups/nmh.c
index c2fd0e61c..0e93186c1 100644
--- a/src/src/lookups/nmh.c
+++ b/src/src/lookups/nmh.c
@@ -347,6 +347,7 @@ while ((cn = nmh_connections))
 gstring *
 nmh_version_report(gstring * g)
 {
+/* NMH has no version api! */
 #ifdef DYNLOOKUP
 g = string_fmt_append(g, "Library version: NMH: Exim version %s\n", EXIM_VERSION_STR);
 #endif
diff --git a/src/src/lookups/passwd.c b/src/src/lookups/passwd.c
index 7bf499920..c22c2d4cc 100644
--- a/src/src/lookups/passwd.c
+++ b/src/src/lookups/passwd.c
@@ -58,10 +58,8 @@ return OK;
 gstring *
 passwd_version_report(gstring * g)
 {
-#ifdef DYNLOOKUP
-g = string_fmt_append(g, "Library version: passwd: Exim version %s\n", EXIM_VERSION_STR);
-#endif
-return g;
+return string_fmt_append(g, "Library version: passwd: Exim %s builtin\n",
+			    EXIM_VERSION_STR);
 }
 
 static lookup_info _lookup_info = {
diff --git a/src/src/lookups/pgsql.c b/src/src/lookups/pgsql.c
index a578645ff..8ddf0e058 100644
--- a/src/src/lookups/pgsql.c
+++ b/src/src/lookups/pgsql.c
@@ -477,9 +477,7 @@ return quoted;
 gstring *
 pgsql_version_report(gstring * g)
 {
-#ifdef DYNLOOKUP
-g = string_fmt_append(g, "Library version: PostgreSQL: Exim version %s\n", EXIM_VERSION_STR);
-#endif
+int ver = PQlibVersion();
 
 /* Version reporting: there appears to be no available information about
 the client library in libpq-fe.h; once you have a connection object, you
@@ -487,6 +485,9 @@ can access the server version and the chosen protocol version, but those
 aren't really what we want.  It might make sense to debug_printf those
 when the connection is established though? */
 
+/* version 9.1 onwards */
+g = string_fmt_append(g, "Library version: PostgreSQL: Runtime: %d.%d\n",
+			ver/10000, ver%10000);
 return g;
 }
 
diff --git a/src/src/lookups/psl.c b/src/src/lookups/psl.c
index 1592fe32d..9171192a3 100644
--- a/src/src/lookups/psl.c
+++ b/src/src/lookups/psl.c
@@ -212,10 +212,8 @@ return psl_gen_find(handle, keystring, length, result, errmsg, TRUE);
 gstring *
 psl_version_report(gstring * g)
 {
-#ifdef DYNLOOKUP
-g = string_fmt_append(g, "Library version: psl: Exim version %s\n", EXIM_VERSION_STR);
-#endif
-return g;
+return string_fmt_append(g, "Library version: psl: Exim %s builtin\n",
+				EXIM_VERSION_STR);
 }
 
 static lookup_info psl_lookup_info = {
diff --git a/src/src/lookups/redis.c b/src/src/lookups/redis.c
index 4b11475d0..a721d0605 100644
--- a/src/src/lookups/redis.c
+++ b/src/src/lookups/redis.c
@@ -433,13 +433,8 @@ return quoted;
 gstring *
 redis_version_report(gstring * g)
 {
-g = string_fmt_append(g,
-  "Library version: REDIS: Compile: %d [%d]\n", HIREDIS_MAJOR, HIREDIS_MINOR);
-#ifdef DYNLOOKUP
-g = string_fmt_append(g,
-  "                        Exim version %s\n", EXIM_VERSION_STR);
-#endif
-return g;
+return string_fmt_append(g, "Library version: REDIS: Compile: %d.%d.%d\n",
+    HIREDIS_MAJOR, HIREDIS_MINOR, HIREDIS_PATCH);
 }
 
 
diff --git a/src/src/lookups/spf.c b/src/src/lookups/spf.c
index e1931ca0f..ce314f7e5 100644
--- a/src/src/lookups/spf.c
+++ b/src/src/lookups/spf.c
@@ -86,10 +86,11 @@ return FAIL;
 gstring *
 spf_version_report(gstring * g)
 {
-#ifdef DYNLOOKUP
-g = string_fmt_append(g, "Library version: SPF: Exim version %s\n", EXIM_VERSION_STR));
-#endif
-return g;
+int maj, min, patch;
+
+SPF_get_lib_version(&maj, &min, &patch);
+return string_fmt_append(g, "Library version: SPF: Runtime: %d.%d.%d\n",
+      maj, min, patch);
 }
 
 
diff --git a/src/src/lookups/sqlite.c b/src/src/lookups/sqlite.c
index 722916cf3..e358c9f84 100644
--- a/src/src/lookups/sqlite.c
+++ b/src/src/lookups/sqlite.c
@@ -172,10 +172,6 @@ g = string_fmt_append(g,
   "Library version: SQLite: Compile: %s\n"
   "                         Runtime: %s\n",
         SQLITE_VERSION, sqlite3_libversion());
-#ifdef DYNLOOKUP
-g = string_fmt_append(g,
-  "                         Exim version %s\n", EXIM_VERSION_STR);
-#endif
 return g;
 }
 
diff --git a/src/src/lookups/testdb.c b/src/src/lookups/testdb.c
index 44d77b8c8..2e3ed36c2 100644
--- a/src/src/lookups/testdb.c
+++ b/src/src/lookups/testdb.c
@@ -83,10 +83,8 @@ return quoted;
 gstring *
 testdb_version_report(gstring * g)
 {
-#ifdef DYNLOOKUP
-g = string_fmt_append(g, "Library version: TestDB: Exim version %s\n", EXIM_VERSION_STR);
-#endif
-return g;
+return string_fmt_append(g, "Library version: TestDB: Exim version %s\n",
+			EXIM_VERSION_STR);
 }
 
 
diff --git a/src/src/lookups/whoson.c b/src/src/lookups/whoson.c
index cd6c7e85c..f783a905a 100644
--- a/src/src/lookups/whoson.c
+++ b/src/src/lookups/whoson.c
@@ -68,13 +68,8 @@ switch (wso_query(CS query, CS buffer, sizeof(buffer)))
 gstring *
 whoson_version_report(gstring * g)
 {
-g = string_fmt_append(g,
+return string_fmt_append(g,
   "Library version: Whoson: Runtime: %s\n", wso_version());
-#ifdef DYNLOOKUP
-g = string_fmt_append(g,
-  "                         Exim version %s\n", EXIM_VERSION_STR);
-#endif
-return g;
 }
 
 static lookup_info _lookup_info = {
diff --git a/src/src/miscmods/spf_perl.c b/src/src/miscmods/spf_perl.c
index d491ae64e..e7bc1e331 100644
--- a/src/src/miscmods/spf_perl.c
+++ b/src/src/miscmods/spf_perl.c
@@ -121,16 +121,14 @@ return g;
 /******************************************************************************/
 
 
-#ifdef notdef
 /*API*/
 static gstring *
 spf_lib_version_report(gstring * g)
 {
 /*XXX Does Mail::SPF have a version? MetaCPAN says yes, but does not
 document a method that returns it. */
-return g;
+return string_fmt_append(g, "Library_version: SPF: perl Mail::SPF\n");
 }
-#endif
 
 
 
@@ -389,7 +387,7 @@ misc_module_info spf_module_info =
 # ifdef DYNLOOKUP
   .dyn_magic =		MISC_MODULE_MAGIC,
 # endif
-  /* .lib_vers_report =	spf_lib_version_report, */
+  .lib_vers_report =	spf_lib_version_report,
   .conn_init =		spf_conn_init,
   .smtp_reset =		spf_smtp_reset,
   .authres =		authres_spf,

